<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审核状态" prop="auditStatus">
        <el-select v-model="queryParams.auditStatus" placeholder="审核状态" clearable size="small">
          <el-option
              v-for="dict in auditStatusList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              @keyup.enter.native="handleQuery"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="anchorApplyList" @selection-change="handleSelectionChange">
<!--      <el-table-column type="selection" width="55" align="center"/>-->
      <el-table-column label="审核状态" align="center" prop="auditStatus">
        <template v-slot="scope">
          <cai-dict-tag :options="auditStatusList" :value="scope.row.auditStatus"/>
        </template>
      </el-table-column>
      <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      <el-table-column label="昵称" align="center" prop="nickname"/>
      <el-table-column label="手机" align="center" prop="mobile"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="性别" align="center" prop="gender">
        <template v-slot="scope">
          <cai-dict-tag :options="genderList" :value="scope.row.gender"/>
        </template>
      </el-table-column>
      <el-table-column label="申请时间" align="center" prop="createTime" width="180"/>
      <el-table-column label="审核时间" align="center" prop="auditTime" width="180"/>
<!--      <el-table-column label="审核备注" align="center" prop="auditRemark"/>-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="220">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-info"
              @click="handleAnchorInfo(scope.row)"
              v-hasPermi="['cai:anchor:query']"
          >详情</el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              v-if="scope.row.auditStatus === 1"
              @click="handleAuditSuccess(scope.row)"
              v-hasPermi="['cai:anchorApply:edit']"
          >通过
          </el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              v-if="scope.row.auditStatus === 1"
              @click="handleAuditFail(scope.row)"
              v-hasPermi="['cai:anchorApply:edit']"
          >不通过
          </el-button>
          <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['cai:anchorApply:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
    />
    <anchor-info-dialog v-if="anchorInfoDialogVisible" ref="anchorInfoDialog" />
  </div>
</template>

<script>
import {auditAnchorFail, auditAnchorSuccess, delAnchorApply, listAnchorApply} from '@/api/cai/anchorApply'
import {auditStatusList, genderList} from '@/constant/statusMap'
import AnchorInfoDialog from "@/views/cai/anchor/anchor-info-dialog";

export default {
  name: "AnchorApply",
  components:{
    AnchorInfoDialog
  },
  data() {
    return {
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      genderList, auditStatusList,
      anchorInfoDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 播主申请管理表格数据
      anchorApplyList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usercode: undefined,
        mobile: undefined,
        auditStatus: 1,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询播主申请管理列表 */
    getList() {
      this.loading = true;
      listAnchorApply(this.queryParams).then(response => {
        this.anchorApplyList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    handleAuditSuccess(row) {
      this.$modal.confirm('是否确认通过用户"' + row.nickname + '"主播审核？').then(() => {
        this.loading = true;
        return auditAnchorSuccess({
          id: row.id,
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleAuditFail(row) {
      this.$modal.confirm('是否不确认通过用户"' + row.nickname + '"主播审核？').then(() => {
        this.loading = true;
        return auditAnchorFail({
          id: row.id,
        });
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除用户"' + row.nickname + '"的主播审核？').then(() => {
        this.loading = true;
        return delAnchorApply(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleAnchorInfo(row){
      this.anchorInfoDialogVisible = true
      this.$nextTick(() => {
        this.$refs.anchorInfoDialog.init(row.userId)
      })
    },
  }
};
</script>
